<?
include("header.php");

function printSearchHeader ($color)
{
?>
<tr class="era<?=$color?>">
    <th style="width:5%" class="ar">Rank</th>
    <th style="width:30%">Empire</th>
    <th style="width:7%" class="ar">Land</th>
    <th style="width:15%" class="ar">Networth</th>
    <th style="width:10%">Race</th>
    <th style="width:5%">Era</th>
    <th style="width:8%">Score</th>
    <th style="width:8%">O</th>
    <th style="width:8%">D</th>
    <th style="width:4%">K</th></tr>
<?
}

function printSearchLine (&$enemy)
{
	global $users, $rtags, $etags, $config;
	$color = "normal";
	if ($enemy[num] == $users[num])
		$color = "self";
	elseif (($enemy[land] == 0) || ($enemy[disabled] == 4))
		$color = "dead";
	elseif ($enemy[disabled] == 2)
		$color = "admin";
	elseif ($enemy[disabled] == 3)
		$color = "disabled";
	elseif (($enemy[turnsused] <= $config[protection]) || ($enemy[vacation] > $config[vacationdelay]))
		$color = "protected";
?>
<tr class="m<?=$color?>">
    <td class="ar"><?if ($enemy[online]) echo "*";?><?=$enemy[rank]?></td>
    <td class="ac"><?=$enemy[empire]?> (#<?=$enemy[num]?>)</td>
    <td class="ar"><?=commas($enemy[land])?></td>
    <td class="ar">$<?=commas($enemy[networth])?></td>
    <td class="ac"><?=$rtags["$enemy[race]"]?></td>
    <td class="ac"><?=$etags["$enemy[era]"]?></td>
    <td class="ac"><?=$enemy[score]?></td>
    <td class="ac"><?=$enemy[offtotal]?> (<?if ($enemy[offtotal]) echo round($enemy[offsucc]/$enemy[offtotal]*100); else echo 0;?>%)</td>
    <td class="ac"><?=$enemy[deftotal]?> (<?if ($enemy[deftotal]) echo round($enemy[defsucc]/$enemy[deftotal]*100); else echo 0;?>%)</td>
    <td class="ac"><?=$enemy[kills]?></td></tr>
<?
}

if ($do_search)
{
	$query = "";
//	fixInputNum($searchlimit);
//	if (!$searchlimit)
		$searchlimit = 25;
	switch ($sort)
	{
	case 'rank':		$order_by = "score DESC";	break;
	case 'networth':	$order_by = "networth DESC";	break;
	case 'num':		$order_by = "num ASC";		break;
	case 'empire':		$order_by = "empire ASC";	break;
	case 'land':		$order_by = "land DESC";	break;
	default:		$order_by = "rank ASC";		break;
	}

	if ($search_type == 'string')
	{
		SQLquotes($search_string);
		$query = "empire LIKE '%$search_string%'";
	}
	elseif ($search_type == 'num')
	{
		fixInputNum($search_num);
		if ($search_num)
			$query = "num=$search_num";
		else	TheEnd("No empire number specified!");
	}
	elseif ($search_type == 'online')
		$query = "online=1";
	else	TheEnd("No search type specified!");

	fixInputNum($search_race);
	if (($search_race) && ($search_race != -1))
		$query .= " AND race=$search_race";

	fixInputNum($search_era);
	if (($search_era) && ($search_era != -1))
		$query .= " AND era=$search_era";

	fixInputNum($search_min_nw);
	if (($search_min_nw) && ($search_nw_min))
		$query .= " AND networth>=$search_min_nw";

	fixInputNum($search_max_nw);
	if (($search_max_nw) && ($search_nw_max))
		$query .= " AND networth<=$search_max_nw";

	$query .= " AND rank>0";

	if ($search_dead)
		$query .= " AND land>0";
	$dbstr = mysql_query("SELECT rank,empire,num,land,networth,race,era,online,disabled,turnsused,vacation,offsucc,offtotal,defsucc,deftotal,kills,score FROM $playerdb WHERE $query ORDER BY $order_by LIMIT $searchlimit;");
	if ($numrows = mysql_num_rows($dbstr))
	{
?>
Color Key: <span class="mprotected">Protected/Vacation</span>, <span class="mdead">Dead</span>, <span class="mdisabled">Disabled</span>, <span class="madmin">Administrator</span>, <span class="mself">You</span><br>
Stats Key: O = Offensive Actions (success%), D = Defenses (success%), K = Number of empires killed<br>
<table class="scorestable">
<?
		printSearchHeader($users[era]);
		while ($enemy = mysql_fetch_array($dbstr))
			printSearchLine($enemy);
		printSearchHeader($users[era]);
?>
</table>
<?
		print "Found $numrows empires matching your criteria.<br>\n";
	}
	else	print "No empires found.<br>\n";
}
else
{
	$search_type = 'string';
	$search_era = -1;
	$search_race = -1;
	$search_min_nw = round($users[networth] / 10);
	$search_max_nw = round($users[networth] * 10);
	$sort = 'rank';
}
?>
<form method="post" action="<?=$config[main]?>?action=search">
<table class="inputtable">
<tr>
    <th class="al"><label><input type="radio" name="search_type" value="num"<?if ($search_type == 'num') echo ' checked';?>>Empire Number:</label></th>
    <td><input type="text" name="search_num" value="<?=$search_num?>" size="4"></td>
    <th class="ar">Sort by:</th>
    <td><input type="radio" name="sort" value="rank"<?if ($sort == 'rank') echo ' checked';?>>Score</td>
</tr>
<tr>
    <th class="al"><label><input type="radio" name="search_type" value="string"<?if ($search_type == 'string') echo ' checked';?>>Empire Name:</label></th>
    <td><input type="text" name="search_string" value="<?=$search_string?>" size="15"></td>
    <th></th>
    <td><input type="radio" name="sort" value="num"<?if ($sort == 'num') echo ' checked';?>>Empire ID</td>
</tr>
<tr>
    <th class="al"><label><input type="radio" name="search_type" value="online"<?if ($search_type == 'online') echo ' checked';?>>Online Search</label></th>
    <td></td>
    <th></th>
    <td><input type="radio" name="sort" value="empire"<?if ($sort == 'empire') echo ' checked';?>>Name</td>
</tr>
<tr>
    <th></th>
    <td></td>
    <th></th>
    <td><input type="radio" name="sort" value="networth"<?if ($sort == 'networth') echo ' checked';?>>Networth</td>
</tr>
<tr>
    <th class="al">In Era:</th>
    <td><select name="search_era">
        <option value="-1"<?if ($search_era == -1) echo ' selected';?>>Any</option>
<?
$eralist = mysql_query("SELECT id,name FROM $eradb;");
while ($era = mysql_fetch_array($eralist))
{
?>
        <option value="<?=$era[id]?>"<?if ($search_era == $era[id]) echo ' selected';?>><?=$era[name]?></option>
<?
}
?>
        </select></td>
    <th></th>
    <td><input type="radio" name="sort" value="land"<?if ($sort == 'land') echo ' checked';?>>Land</td>
</tr>
<tr>
    <th class="al"><label>Race:</label></th>
    <td><select name="search_race">
        <option value="-1"<?if ($search_race == -1) echo ' selected';?>>Any</option>
<?
$races = mysql_query("SELECT id,name FROM $racedb;");
while ($race = mysql_fetch_array($races))
{
?>
        <option value="<?=$race[id]?>"<?if ($search_race == $race[id]) echo ' selected';?>><?=$race[name]?></option>
<?
}
?>
        </select></td>
    <th class="al" colspan="2"><label><input type="checkbox" name="search_dead" value="1"<?if ($search_dead) echo ' checked';?>>Exclude dead empires</th>
</tr>
<tr>
    <th class="al"><label><input type="checkbox" name="search_nw_min"<?if ($search_nw_min) echo " checked";?>>Min Networth:</label></th>
    <td>$<input type="text" name="search_min_nw" size="9" value="<?=commas($search_min_nw)?>"></td>
    <th class="al"><label><input type="checkbox" name="search_nw_max"<?if ($search_nw_max) echo " checked";?>>Max Networth:</label></th>
    <td>$<input type="text" name="search_max_nw" size="9" value="<?=commas($search_max_nw)?>"></td>
</tr>
<tr><td colspan="4" class="ac"><input type="submit" name="do_search" value="Search"></td></tr>
</table>
</form>
<?
TheEnd("");
?>
