<?
include("spells.php");

// Stock functions for spell success/failure, so we don't have to edit them all individually
function SpellSucceed ($msg)
{
	global $users, $enemy, $spell_num, $sppoints;
	if ($sppoints["$spell_num"])
	{
		$pts = ceil(findScorePoints($users, $enemy) * $sppoints["$spell_num"]);
		$users[score] += $pts;
		$enemy[score]--;
	}
	else	$pts = 0;
?>
You cast the spell and it is <span class="cgood">successful</span>! (+<?=$pts.' '.plural($pts,'pts','pt')?>)<br>
<?=$msg?><br>
<?
}

function SpellFail ()
{
	global $users, $uera, $wizloss, $enemy, $spell_num, $sppoints;
	if ($sppoints["$spell_num"])
	{
		$pts = ceil(findScorePoints($users, $enemy) * $sppoints["$spell_num"] * 0.5);
		$users[score] -= $pts;
		$enemy[score]++;
	}
	else	$pts = 0;
?>
You cast the spell and it <span class="cbad">fizzles</span>! (-<?=$pts.' '.plural($pts,'pts','pt')?>)<br>
<?=$wizloss?> <?=$uera[wiztrp]?> are killed in an explosion!<br>
<?
	$users[wiztrp] -= $wizloss;
}

function SpellShielded ($msg)
{
	global $users, $enemy, $spell_num, $sppoints;
	if ($sppoints["$spell_num"])
	{
		$pts = 1;
		$users[score]++;
		$enemy[score]--;
	}
	else	$pts = 0;
?>
You cast the spell and it is <span class="cgood">successful</span>, but <span class="cwarn">partially blocked</span>. (+<?=$pts.' '.plural($pts,'pts','pt')?>)<br>
<?=$msg?><br>
<?
}

function printMRow ($num)
{
	global $spname, $sptype, $spcost, $uera;
	global $spell_num;
?>
        <option value="<?=$num?>"<?if ($spell_num == $num) print " selected";?>><?=$spname[$num]?> (<?=commas($spcost[$num])?> <?=$uera[runes]?>) <?if ($sptype[$num] == d) echo "(Self)"?></option>
<?
}

function setspcost()
{	
	global $users, $urace, $sptype, $spcost, $sppoints;
	// this chunk sets the costs of spells
	// array was created so that it's easier to reference
	$manabase = ($users[land] * .1) + 100 + ($users[wizbld] * .2) * $urace[magic] * calcSizeBonus($users[networth]);
	// sptype is "o" for offense, "d" for defense
	$spcost[1]  = ceil($manabase *  1.00);	$sptype[1] = "o";	$sppoints[1] = 0;	// Crystal Ball

	$spcost[2]  = ceil($manabase *  2.50);	$sptype[2] = "o";	$sppoints[2] = 0.2;	// Fireball
	$spcost[3]  = ceil($manabase *  4.90);	$sptype[3] = "d";	$sppoints[3] = 0;	// Spell Shield

	$spcost[4]  = ceil($manabase *  7.25);	$sptype[4] = "o";	$sppoints[4] = 0.3;	// Storms
	$spcost[5]  = ceil($manabase *  9.50);	$sptype[5] = "o";	$sppoints[5] = 0.4;	// Lightning Strike
	$spcost[6]  = ceil($manabase * 18.00);	$sptype[6] = "o";	$sppoints[6] = 0.5;	// Wrath of Demons

	$spcost[7]  = ceil($manabase * 17.00);	$sptype[7] = "d";	$sppoints[7] = 0;	// Cornocopia
	$spcost[8]  = ceil($manabase * 17.50);	$sptype[8] = "d";	$sppoints[8] = 0;	// Tree of Gold

	$spcost[9]  = ceil($manabase * 20.00);	$sptype[9] = "d";	$sppoints[9] = 0;	// Open Time Gate
	$spcost[10] = ceil($manabase * 14.50);	$sptype[10] = "d";	$sppoints[10] = 0;	// Close Time Gate

	$spcost[11] = ceil($manabase * 22.75);	$sptype[11] = "o";	$sppoints[11] = 1.0;	// Magic User Fight
	$spcost[12] = ceil($manabase * 25.75);	$sptype[12] = "o";	$sppoints[12] = 0.15;	// Embezzlement

	$spcost[13] = ceil($manabase * 47.50);	$sptype[13] = "d";	$sppoints[13] = 0;	// Advance
}

function setspnames()
{
	global $spname, $users;
	if ($users[era] == 1)
	{
		$spname[1] = "Crystal Ball";		$spname[2] = "Fireball";	$spname[3] = "Spell Shield";
		$spname[6] = "Wrath of Demons";
		$spname[13] = "Advance to Present";
	}
	elseif ($users[era] == 2)
	{
		$spname[1] = "Mind Observation";	$spname[2] = "Psionic Storm";	$spname[3] = "Psionic Shield";
		$spname[6] = "Rage of Angels";
		$spname[13] = "Advance to Future";
	}
	elseif ($users[era] == 3)
	{
		$spname[1] = "High Orbit Blanket";	$spname[2] = "Energy Storm";	$spname[3] = "Energy Shield";
		$spname[6] = "Nanotech Warriors";
		$spname[13] = "";
	}
	$spname[4] = "Storms";
	$spname[5] = "Lightning Strike";
	$spname[7] = "Cornucopia";
	$spname[8] = "Tree of Gold";
	$spname[9] = "Open Time Gate";
	$spname[10] = "Close Time Gate";
	$spname[11] = "Magic User Fight";
	$spname[12] = "Embezzlement";

	if ($users[turnsused] < 500 * $users[era])
		$spname[13] = "";
}
setspcost();
setspnames();
if ($do_spell)
{
	if ($spell_num == 0)
		TheEnd("You must specify a spell!");
	if (!$spname["$spell_num"])
		TheEnd("Invalid spell specified!");
	if ($users[turns] < 2)
		TheEnd("Not enough turns!");
	if ($users[runes] < $spcost["$spell_num"])
		TheEnd("Not enough $uera[runes]!");
	if ($users[health] < 20)
		TheEnd("Due to their waning health, your $uera[wiztrp] cannot cast any spells.");

	if ($sptype["$spell_num"] == o)			// offense spell?
	{
		fixInputNum($target);
		if (!$target)
			TheEnd("You must specify a target!");
		if ($target == $users[num])
			TheEnd("You may not attack yourself!");
		$enemy = loadUser($target);
		if ($enemy[num] != $target)
			TheEnd("No such user!");
		$erace = loadRace($enemy[race]);
		$eera = loadEra($enemy[era]);

		if ($enemy[land] == 0)
			TheEnd("That empire is dead!");
		if ($enemy[disabled] == 2)
			TheEnd("Cannot use magic on Administrators!");
		if ($enemy[disabled] == 3)
			TheEnd("Cannot use magic on disabled empires!");
		if ($enemy[turnsused] <= $config[protection])
			TheEnd("Cannot use magic on empires under protection!");
		if ($enemy[vacation] > $config[vacationdelay])
			TheEnd("That empire is on vacation!");
		if (($enemy[era] != $users[era]) && ($users[gate] <= $time) && ($enemy[gate] <= $time))
			TheEnd("Need to open a Time Gate first!");

		$netmult = 50;
		if ($spell_num != 1)
		{
			if ($enemy[networth] && ($enemy[networth] < $users[networth] / $netmult))
				TheEnd("Your $uera[wiztrp] politely refuse your orders to target a defenseless empire!");
			if ($enemy[networth] && ($enemy[networth] > $users[networth] * $netmult))
				TheEnd("Your $uera[wiztrp] flatly refuse to target such a strong opponent!");

			$revolt = 1;
			if ($enemy[networth] && ($enemy[networth] < $users[networth] / 5))
			{				// Shame is less powerful than fear
?><span class="cwarn">Your <?=$uera[wiztrp]?> are shamed by your attack on such a weak opponent. Many desert!</span><br>
<?				$revolt = 1 - $users[networth] / $enemy[networth] / 250;
			}
			elseif ($enemy[networth] && ($enemy[networth] > $users[networth] * 5))
			{
?><span class="cwarn">Your <?=$uera[wiztrp]?> tremble at your attack on such a strong opponent. Many desert!</span><br>
<?				$revolt = 1 - $users[networth] / $enemy[networth] / 200;
			}
			if ($revolt < .9)
				$revolt = .9;
			$users[wiztrp] = ceil($users[wiztrp] * $revolt);
			$users[health] -= 6;
			$users[offtotal]++;
			$enemy[deftotal]++;
		}
								// for offense, wizards/avgland
		$uratio = $users[wiztrp] / (($users[land] + $enemy[land]) / 2) * $urace[magic];
		$eratio = $enemy[wiztrp] / $enemy[land] * 1.05 * $erace[magic];
	}
	if ($users[wizbld])					// for defense, wizards/towers
		$lratio = $users[wiztrp] / $users[wizbld] * $urace[magic];
	else	$lratio = 0;

	// lose 1%-5% of your wizards if spell fails
	$wizloss = mt_rand(ceil($users[wiztrp] * .01),ceil($users[wiztrp] * .05 + 1));
	if ($wizloss > $users[wiztrp])
		$wizloss = $users[wiztrp];

	if ((1 <= $spell_num) && ($spell_num <= 13))
	{
		if ($enemy[shield] > $time)
			$shmod = 1/3;
		else	$shmod = 1;
		CastSpell($spell_num);
	}
	$users[runes] -= $spcost["$spell_num"];
	saveUserData($users,"offsucc offtotal kills score");
	if ($enemy[num])
		saveUserData($enemy,"defsucc deftotal score");
	takeTurns(2,'magic');
}
?>
