<?
include("header.php");

$offpts = ($users[armtrp] * $uera[o_armtrp]) + ($users[lndtrp] * $uera[o_lndtrp]) + ($users[flytrp] * $uera[o_flytrp]) + ($users[seatrp] * $uera[o_seatrp]);
$defpts = ($users[armtrp] * $uera[d_armtrp]) + ($users[lndtrp] * $uera[d_lndtrp]) + ($users[flytrp] * $uera[d_flytrp]) + ($users[seatrp] * $uera[d_seatrp]);

$offpts = round($offpts * $urace[offense]);
$defpts = round(($defpts + ($users[defbld] * 500)) * $urace[defense]);
$size = calcSizeBonus($users[networth]);

$foodpro = round(($users[freeland] * 10) + ($users[foodbld] * 85) * sqrt(1 - 0.75 * $users[foodbld] / $users[land]) * $urace[farms]);
$foodcon = round((($users[armtrp] * .05) + ($users[lndtrp] * .03) + ($users[flytrp] * .02) + ($users[seatrp] * .01) + ($users[peasants] * .01) + ($users[wiztrp] * .25)) * $urace[food]);
$foodnet = $foodpro - $foodcon;

$income = round(((pci($users,$urace) * ($users[tax] / 100) * ($users[health] / 100) * $users[peasants]) + ($users[cashbld] * 500)) / $size);
$loanpayment = round($users[loan] / 200);
$expenses = round(($users[armtrp] * 1) + ($users[lndtrp] * 2.5) + ($users[flytrp] * 4) + ($users[seatrp] * 7) + ($users[land] * 8) + ($users[wiztrp] * 0.5) + ($users[food] * 0.01));
$expbonus = (1 - $urace[costs]) + ($users[costbld] / $users[land]);
if ($expbonus > 0.5)				// expenses bonus limit
	$expbonus = 0.5;
$expenses -= round($expenses * $expbonus);
$netincome = $income - $expenses - $loanpayment;

$savrate = $config[savebase] - $size;
$loanrate = $config[loanbase] + $size;
?>
<table style="width:100%">
<tr><th colspan="3" class="era<?=$users[era]?>"><?=$users[empire]?> (#<?=$users[num]?>)</th></tr>
<tr><td style="vertical-align:top;width:33%">
        <table class="empstatus" style="width:100%">
        <tr><th colspan="2" class="era<?=$users[era]?>" style="text-align:center">Empire</th></tr>
        <tr><th>Money:</th>
            <td>$<?=commas($users[cash])?></td></tr>
        <tr><th>Networth:</th>
            <td>$<?=commas($users[networth])?></td></tr>
        <tr><th>Population:</th>
            <td><?=commas($users[peasants])?></td></tr>
        <tr><th>Race:</th>
            <td><?=$urace[name]?></td></tr>
        <tr><th>Era:</th>
            <td><?=$uera[name]?></td></tr>
        </table>
    </td>
    <td style="vertical-align:top;width:33%">
        <table class="empstatus" style="width:100%">
        <tr><th colspan="2" class="era<?=$users[era]?>" style="text-align:center">Agriculture</th></tr>
        <tr><th>Est. Production:</th>
            <td><?=commas($foodpro)?></td></tr>
        <tr><th>Est. Consumption:</th>
            <td><?=commas($foodcon)?></td></tr>
        <tr><th>Net:</th>
            <td><?printCNum($foodnet,"",0);?></td></tr>
        </table>
    </td>
    <td style="vertical-align:top;width:33%">
        <table class="empstatus" style="width:100%">
        <tr><th colspan="2" class="era<?=$users[era]?>" style="text-align:center">Stats</th></tr>
        <tr><th>Turns Used:</th>
            <td><?=commas($users[turnsused])?></td></tr>
        <tr><th>Rank:</th>
            <td>#<?=$users[rank]?></td></tr>
        <tr><th>Offensive Actions:</th>
            <td><?=$users[offtotal]?> (<?if ($users[offtotal]) echo round($users[offsucc]/$users[offtotal]*100); else echo 0;?>%)</td></tr>
        <tr><th>Defenses:</th>
            <td><?=$users[deftotal]?> (<?if ($users[deftotal]) echo round($users[defsucc]/$users[deftotal]*100); else echo 0;?>%)</td></tr>
        <tr><th>Kills:</th>
            <td><?=$users[kills]?></td></tr>
        </table>
    </td>
</tr>
<tr><td style="vertical-align:top;width:33%">
        <table class="empstatus" style="width:100%">
        <tr><th colspan="2" class="era<?=$users[era]?>" style="text-align:center">Land Division</th></tr>
        <tr><th><?=$uera[popbld]?>:</th>
            <td><?=commas($users[popbld])?></td></tr>
        <tr><th><?=$uera[cashbld]?>:</th>
            <td><?=commas($users[cashbld])?></td></tr>
        <tr><th><?=$uera[trpbld]?>:</th>
            <td><?=commas($users[trpbld])?></td></tr>
        <tr><th><?=$uera[costbld]?>:</th>
            <td><?=commas($users[costbld])?></td></tr>
        <tr><th><?=$uera[wizbld]?>:</th>
            <td><?=commas($users[wizbld])?></td></tr>
        <tr><th><?=$uera[foodbld]?>:</th>
            <td><?=commas($users[foodbld])?></td></tr>
        <tr><th><?=$uera[defbld]?>:</th>
            <td><?=commas($users[defbld])?></td></tr>
        <tr><th>Unused Land:</th>
            <td><?=commas($users[freeland])?></td></tr>
        </table>
    </td>
    <td style="vertical-align:top;width:33%">
        <table class="empstatus" style="width:100%">
        <tr><th colspan="2" class="era<?=$users[era]?>" style="text-align:center">Finances</th></tr>
        <tr><th>Est. Income:</th>
            <td>$<?=commas($income)?></td></tr>
        <tr><th>Est. Expenses:</th>
            <td>$<?=commas($expenses)?></td></tr>
        <tr><th>Net:</th>
            <td><?printCNum($netincome,"$",0);?></td></tr>
        <tr><th>Loan Payment:</th>
            <td>$<?=commas($loanpayment)?></td></tr>
        <tr><th>Per Cap income:</th>
            <td>$<?=pci($users,$urace)?></td></tr>
        <tr><td colspan="2">&nbsp;</td></tr>
        <tr><th>Savings Balance:</th>
            <td>$<?=commas($users[savings])?> (<?=$savrate?>%)</td></tr>
        <tr><th>Loan Balance:</th>
            <td>$<?=commas($users[loan])?> (<?=$loanrate?>%)</td></tr>
        </table>
    </td>
    <td style="vertical-align:top;width:33%">
        <table class="empstatus" style="width:100%">
        <tr><th colspan="2" class="era<?=$users[era]?>" style="text-align:center">Military</th></tr>
        <tr><th><?=$uera[armtrp]?>:</th>
            <td><?=commas($users[armtrp])?></td></tr>
        <tr><th><?=$uera[lndtrp]?>:</th>
            <td><?=commas($users[lndtrp])?></td></tr>
        <tr><th><?=$uera[flytrp]?>:</th>
            <td><?=commas($users[flytrp])?></td></tr>
        <tr><th><?=$uera[seatrp]?>:</th>
            <td><?=commas($users[seatrp])?></td></tr>
        <tr><th><?=$uera[wiztrp]?>:</th>
            <td><?=commas($users[wiztrp])?></td>
        <tr><td colspan="2">&nbsp;</td></tr>
        <tr><th>Offensive Points:</th>
            <td><?=commas($offpts)?></td></tr>
        <tr><th>Defensive Points:</th>
            <td><?=commas($defpts)?></td></tr>
        </table>
    </td>
</tr>
</table>
<?
TheEnd("");
?>
